#!/usr/bin/env python

__authors__ = "Martin Sandve Alnes"
__date__ = "2012-05-16"

from unittest import TestCase
import swiginac
import SyFi

class TestElements(TestCase):

    def test_lagrange_elements(self):
        SyFi.initSyFi(3)
        cells = [SyFi.ReferenceLine(),
                 SyFi.ReferenceTriangle(),
                 SyFi.ReferenceTetrahedron(),
                 SyFi.ReferenceRectangle(),
                 SyFi.ReferenceBox()]
        for cell in cells:
            dim = cell.no_space_dim()
            for order in (1,2):
                fe = SyFi.Lagrange(cell, order)
                self.assertEqual(fe.get_order(), order)
                #self.assertEqual(fe.get_polygon(), cell)
                for i in range(fe.nbf()):
                    N = fe.N(i)
                    dof = fe.dof(i)
                    # TODO: Assert something
